package language.injection;

import com.intellij.codeInsight.editorActions.enter.EnterHandlerDelegateAdapter;
import com.intellij.openapi.actionSystem.DataContext;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.editor.actionSystem.EditorActionHandler;
import com.intellij.openapi.util.Ref;
import com.intellij.psi.PsiFile;
import com.intellij.psi.impl.source.tree.injected.InjectedLanguageUtil;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.plugins.groovy.GroovyFileType;
import org.jetbrains.yaml.YAMLFileType;

/**
 * Created with IntelliJ IDEA.
 * User: Marcin Rembała
 * Date: 2015-03-10
 */
public class GroovyInYAMLEnterHandlerDelegate extends EnterHandlerDelegateAdapter {
    @Override
    public Result preprocessEnter(@NotNull PsiFile file, @NotNull Editor editor, @NotNull Ref<Integer> caretOffset, @NotNull Ref<Integer> caretAdvance, @NotNull DataContext dataContext, EditorActionHandler originalHandler) {
        if (file.getFileType() == GroovyFileType.GROOVY_FILE_TYPE) {
            final PsiFile topLevelFile = InjectedLanguageUtil.getTopLevelFile(file);
            if (topLevelFile != null && topLevelFile.getFileType() == YAMLFileType.YML) {
                return Result.DefaultSkipIndent;
            }
        }
        return Result.Continue;
    }

}
