package language.injection;

import com.intellij.openapi.util.TextRange;
import com.intellij.psi.LiteralTextEscaper;
import org.jetbrains.annotations.NotNull;

/**
 * Created with IntelliJ IDEA.
 * User: Marcin Rembała
 * Date: 18.02.15
 */
public class ScriptBlockLiteralTextEscaper extends LiteralTextEscaper<YamlScriptBlockInjectionHost> {

    protected ScriptBlockLiteralTextEscaper(@NotNull YamlScriptBlockInjectionHost host) {
        super(host);
    }

    @Override
    public boolean decode(@NotNull TextRange rangeInsideHost, @NotNull StringBuilder outChars) {
        final String text = myHost.getText();
        final int startOffset = rangeInsideHost.getStartOffset();
        final int endOffset = rangeInsideHost.getEndOffset();
        if (text.length() < endOffset) {
            outChars.append(text.substring(startOffset));
        } else {
            outChars.append(text.substring(startOffset, endOffset));
        }
        return true;
    }

    @Override
    public int getOffsetInHost(int offsetInDecoded, @NotNull TextRange rangeInsideHost) {
        return offsetInDecoded + rangeInsideHost.getStartOffset();
    }

    @Override
    public boolean isOneLine() {
        return false;
    }
}
